﻿@page "/tasks/view/{programmingTaskId:guid}"
@using System.Threading
@using Microsoft.EntityFrameworkCore
@using Microsoft.Extensions.Localization
@using OWebApplication.Operators
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<TasksArchive> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<style>
    .integrated-ide-pane
    {
        background: #2e2e2e;
        color: #ffffff;
        border-radius: 0;
    }
    
    .programming-task-description-pane *
    {
        user-select: text !important;
        -moz-user-select: text !important;
        -webkit-user-select: text !important;
    }
    .programming-task-description-pane img { max-width: 100%; !important; }
    .programming-task-description-pane p, .programming-task-description-pane span {
        font-size: 1.05rem !important;
        margin-bottom: 10px !important;
    }
    .programming-task-description-pane p:last-child { margin-bottom: 0 !important; }
</style>

@* Integrated code editor component pane *@
<MudPaper Outlined="false" Elevation="10" Class="integrated-ide-pane pa-0 py-2 ma-0">
    <MudContainer MaxWidth="MaxWidth.Medium" Style="height: 500px; position: relative;">
        @if (_programmingTaskInfo is not null)
        {
            <CodeEditorComponent ProgrammingTaskId="@ProgrammingTaskId"/>
        }
        else
        {
            <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="100%"/>
        }
    </MudContainer>
</MudPaper>
@* /Integrated code editor component pane *@

@* Task information container *@
<MudContainer MaxWidth="MaxWidth.Medium" Class="py-10">
    @* Task basic information *@
    <MudToolBar Class="px-0" Style="height: auto;">
        @* Task basic information pane *@
        <MudPaper Outlined="false" Elevation="0">
            @if (_programmingTaskInfo is not null)
            {
                @* Task display title *@
                <MudText Typo="Typo.h5" Class="mb-1" Style="font-weight: bold; line-height: 1;">@_programmingTaskInfo.Title</MudText>
                 @* /Task display title *@
                
                @* Informational chips *@
                <MudText Typo="Typo.body2" Style="font-weight: normal; line-height: 1;">
                    @* Task category *@
                    <MudChip Variant="Variant.Text" Size="Size.Small" Class="ma-0">@(_programmingTaskInfo.Category ?? _localizer["Без категорії"])</MudChip>
                    @* Task difficulty *@
                    <MudChip Variant="Variant.Text" Size="Size.Small" Class="ma-0">@_localizer["Складність: {0}%", _programmingTaskInfo.Difficulty]</MudChip>
                </MudText>
                @* /Informational chips *@
            }
            else
            {
                <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="200px" Height="42px"></MudSkeleton>
            }
        </MudPaper>
        @* /Task basic information pane *@
        
        <MudSpacer/>
        
        @* Menu of administrative actions on the task *@
        @if (_currentUserIsAdmin)
        {
            <MudMenu Icon="@Icons.Material.Filled.MoreVert" Disabled="@(_programmingTaskInfo == null)" AnchorOrigin="@Origin.BottomRight" TransformOrigin="Origin.TopRight">
                @* Edit task details *@
                <MudMenuItem Icon="@Icons.Material.Filled.Edit"
                             OnClick="OnEditTaskButtonClickedAsync"
                >@_localizer["Редагувати"]</MudMenuItem>
                
                @* Edit task options *@
                <MudMenuItem Icon="@Icons.Material.Filled.Settings"
                             OnClick="OnEditTaskOptionsButtonClickedAsync"
                >@_localizer["Налаштування"]</MudMenuItem>

                @* Export the task *@
                <MudMenuItem Icon="@Icons.Material.Filled.ImportExport"
                             OnClick="@(() => _snackbar.Add(_localizer["Coming soon!"], Severity.Warning))"
                >@_localizer["Експортувати завдання"]</MudMenuItem>

                @* Delete the task from the system *@
                <MudMenuItem Icon="@Icons.Material.Filled.DeleteForever"
                             OnClick="OnDeleteTaskButtonClickedAsync"
                >@_localizer["Видалити завдання"]</MudMenuItem>
            </MudMenu>
        }
        @* /Menu of administrative actions on the task *@
    </MudToolBar>
    @* /Task basic information *@
    
    @* Task description *@
    <MudPaper Outlined="true" Elevation="0" Class="programming-task-description-pane pa-4 mt-10">
        @if (_programmingTaskInfo is not null)
        {
            @((MarkupString)_programmingTaskInfo.Description)
        }
        else
        {
            for (var i = 0; i < 10; i++)
            {
                <MudSkeleton SkeletonType="SkeletonType.Text" Width="100%"></MudSkeleton>
            }
        }
    </MudPaper>
    @* /Task description *@
</MudContainer>
@* /Task information container *@

@* Scroll to top button *@
<MudScrollToTop>
    <MudFab Color="Color.Dark" Icon="@Icons.Filled.ArrowUpward" />
</MudScrollToTop>
@* /Scroll to top button *@

@code {
    private SemaphoreSlim _semaphore;
    
    [Parameter]
    public Guid ProgrammingTaskId { get; set; }

    private Guid _currentUserId;
    private bool _currentUserIsAdmin;

    private ProgrammingTask _programmingTaskInfo;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _semaphore = new SemaphoreSlim(1, 1);
        
        _currentUserId = await GetCurrentUserIdAsync();
        _currentUserIsAdmin = await IsSuperUserAsync(_currentUserId);

        _programmingTaskInfo = null;

        async Task<Guid> GetCurrentUserIdAsync()
        {
            var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            return new Guid(_userManager.GetUserId(authenticationState.User));
        }

        async Task<bool> IsSuperUserAsync(Guid userId)
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            return await _userAccessControlOperator.HasUserTypeAsync(databaseContext,
                userId, UserType.SuperUser);
        }
    }
    
    protected override async Task OnParametersSetAsync()
    {
        await base.OnParametersSetAsync();
        await GetProgrammingTaskInformationAsync();
    }
    
    private async Task GetProgrammingTaskInformationAsync()
    {
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            
            var programmingTaskInfo = await databaseContext.ProgrammingTasks
                .Where(t => t.Id == ProgrammingTaskId)
                .Select(s => new ProgrammingTask
                {
                    Id = s.Id,
                    Enabled = s.Enabled,
                    Title = s.Title,
                    Category = s.Category,
                    Difficulty = s.Difficulty,
                    Description = s.Description
                }).AsNoTracking().FirstOrDefaultAsync();
            
            // Check whether specified task is not exists or not accessible for a student or curator (disabled)
            if (programmingTaskInfo is null || (!programmingTaskInfo.Enabled && !_currentUserIsAdmin))
            {
                _snackbar.Add(_localizer["Завдання зі вказаним ідентифікатором не знайдено!"],
                    Severity.Error, options => options.CloseAfterNavigation = false);
                _navigationManager.NavigateTo("/tasks/archive");
                return;
            }

            _programmingTaskInfo = programmingTaskInfo;
            StateHasChanged();
        }
        finally { _semaphore.Release(); }
    }

    private async Task OnEditTaskButtonClickedAsync()
    {
        var programmingTaskInfo = _programmingTaskInfo;
        _programmingTaskInfo = null;
        
        await _dialogService.ShowMessageBox(new MessageBoxOptions
        {
            Title = _localizer["Редагування завдання"],
            Message = _localizer[
                "Ви можете відредагувати це завдання, експортувавши його, і скориставшись програмним забезпеченням " +
                "Overtest TaskForce (рекомендовано), або звичайним редактором коду накшталт Visual Studio Code. За " +
                "детальною інформацією про створення і редагування завдань завітайте до документації Overtest."],
            CancelText = _localizer["Зрозуміло"],
            YesText = null, NoText = null
        }, new DialogOptions
        {
            CloseButton = true,
            DisableBackdropClick = true,
            FullWidth = true,
            MaxWidth = MaxWidth.Small,
            Position = DialogPosition.Center
        });

        _programmingTaskInfo = programmingTaskInfo;
    }

    private async Task OnEditTaskOptionsButtonClickedAsync()
    {
        if (!_currentUserIsAdmin)
            return;
        
        _programmingTaskInfo = null;
        
        var parameters = new DialogParameters { ["ProgrammingTaskId"] = ProgrammingTaskId };
        await _dialogService.Show<ProgrammingTaskOptionsDialog>(null, parameters).Result;

        await GetProgrammingTaskInformationAsync();
    }
    
    private async Task OnDeleteTaskButtonClickedAsync()
    {
        if (!_currentUserIsAdmin)
            return;
        
        _programmingTaskInfo = null;
        
        var parameters = new DialogParameters { ["ProgrammingTaskId"] = ProgrammingTaskId };
        await _dialogService.Show<ProgrammingTaskRemovalDialog>(null, parameters).Result;

        await GetProgrammingTaskInformationAsync();
    }
}